Subject: Re: [PATCHv3 net-next] rtnetlink: Honour NLM_F_ECHO flag in rtnl_{new, set, del}link

From: Guillaume Nault <[email-masked]>
Date: Wed, 28 Sep 2022 11:47:57 +0200

On Wed, Sep 28, 2022 at 10:39:49AM +0800, Hangbin Liu wrote:
> On Tue, Sep 27, 2022 at 07:21:30AM -0700, Jakub Kicinski wrote:
> > On Tue, 27 Sep 2022 12:13:03 +0800 Hangbin Liu wrote:
> > > @@ -3382,6 +3401,12 @@ static int rtnl_newlink_create(struct sk_buff *skb, struct ifinfomsg *ifm,
> > >  		if (err)
> > >  			goto out_unregister;
> > >  	}
> > > +
> > > +	nskb = rtmsg_ifinfo_build_skb(RTM_NEWLINK, dev, 0, 0, GFP_KERNEL, NULL,
> > > +				      0, pid, nlh->nlmsg_seq);
> > > +	if (nskb)
> > > +		rtnl_notify(nskb, dev_net(dev), pid, RTNLGRP_LINK, nlh, GFP_KERNEL);
> > > +
> > >  out:
> > >  	if (link_net)
> > >  		put_net(link_net);
> > 
> > I'm surprised you're adding new notifications. Does the kernel not
> > already notify about new links? I thought rtnl_newlink_create() ->
> > rtnl_configure_link() -> __dev_notify_flags() sends a notification,
> > already.
> 
> I think __dev_notify_flags() only sends notification when dev flag changed.
> On the other hand, the notification is sent via multicast, while this patch
> is intend to unicast the notification to the user space.

In rntl_configure_link(), dev->rtnl_link_state is RTNL_LINK_INITIALIZING
on device cretation, so __dev_notify_flags() is called with gchanges=~0
and notification should be always sent. It's just a matter of passing the
portid and the nlmsghdr down the call chain to make rtnl_notify() send
the unicast message together with the multicast ones.

Now for device modification, I'm not sure there's a use case for
unicast notifications. The caller already knows which values it asked
to modify, so ECHO doesn't bring much value compared to a simple ACK.

> Thanks
> Hangbin